#property  copyright "dave88 modified jpkfox initial work"
#property  link      "http://www.strategybuilderfx.com/forums/showthread.php?t=15274&page=1&pp=8"
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 3
//----
#property  indicator_color1  Blue
#property  indicator_color2  Aqua
#property  indicator_color3 Yellow
//---- indicator parameters
extern int MaPeriod       =20;  // 
extern int MaMethod_0to3  =1; // 0 = SMA, 1 = EMA, 2 = SMMA, 3 = LWMA
extern int AppliedPrice_0to6=  0; // 0 = Close, 1 = Open, 2 = High, 3 = Low, 4 = Median, 5 = Typical, 6 = Weighted Close
//---- indicator buffers
double Above_BB_Buffer[];
double Below_BB_Buffer[];
double Between_BB_Buffer[];
double c0;
double c1;
double c2;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,4);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);

//---- 3 indicator buffers mapping
   if(!SetIndexBuffer(0,Above_BB_Buffer) &&
      !SetIndexBuffer(1,Below_BB_Buffer) &&
      !SetIndexBuffer(2,Between_BB_Buffer))
      Print("cannot set indicator buffers!");

//---- name for DataWindow and indicator subwindow label
   //IndicatorShortName("rel position");
   IndicatorShortName("rel position");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Relative Position price to channel                                               |
//+------------------------------------------------------------------+
int start()
  {
   int nLimit, i;
   int nCountedBars;
   double price;
   double high;
   double low;
   
  
   nCountedBars=IndicatorCounted();
//---- check for possible errors
   if(nCountedBars<0)
      return(-1);
//---- last counted bar will be recounted
   if(nCountedBars>0)
      nCountedBars--;
   nLimit=Bars-nCountedBars;
   
//---- main loop
   for(i=0; i<nLimit; i++)
     {
      Below_BB_Buffer[i]=0.0;
      Above_BB_Buffer[i]=0.0;
      Between_BB_Buffer[i]=0.0;
//---------------------------------------------------------------------------------------------------
//    c0= moving average line
//    c1= upper one standard deviation bollinger band
//    c2= lower one standard deviation bollinger band
//---------------------------------------------------------------------------------------------------

      c0=(iMA(Symbol(),0,MaPeriod,0,MaMethod_0to3,AppliedPrice_0to6,i));
      c1=(iMA(Symbol(),0,100,0,MODE_SMA,PRICE_CLOSE,i)+iStdDev(NULL,0,100,0,MODE_SMA,PRICE_CLOSE,i));
      c2=(iMA(Symbol(),0,100,0,MODE_SMA,PRICE_CLOSE,i)-iStdDev(NULL,0,100,0,MODE_SMA,PRICE_CLOSE,i));
      
      
      if(c0>c1)
      high=c0;
      low=c1;   
      Above_BB_Buffer[i]=price;

      else if (c0<c2)
      high=c2;
      low=c0;
      Below_BB_Buffer[i]=price;

      else if (c0<=c1 && c0>=c2)
      high=c1;
      low=c2;
      Between_BB_Buffer[i]=price;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+

